exports.translate = function (xml) {

    const convert = require('xml-js');
    const blocks = require('./blocks.js');

    //let xmlData = '<xml><variables><variable type="" id="`jEk@4|i[#Fk?(8x)AV.-my variable" islocal="false" iscloud="false">minha variável</variable></variables><block type="operator_equals" id="2psYQAdSMjzf6#SD4:)j" x="159" y="432"><value name="OPERAND1"><shadow type="text" id="3*Z?vOpjZW:0w=jt9/{+"><field name="TEXT"></field></shadow><block type="operator_divide" id="Ri%cU[$SXFwv:n%FBsQk"><value name="NUM1"><shadow type="math_number" id="0({NE}8kD5![wySb`||K"><field name="NUM">20</field></shadow></value><value name="NUM2"><shadow type="math_number" id="Fww`Sb!Xdi(h31$ip@$d"><field name="NUM">30</field></shadow></value></block></value><value name="OPERAND2"><shadow type="text" id="hwl-0p7_wYf+2s6A|[KX"><field name="TEXT">50</field></shadow></value></block></xml>';

    let jsonData = JSON.parse(convert.xml2json(xml, { compact: true, space: 4 }));

    let code = '';

    jsonData = jsonData['xml']['block'];

    function translate(rawBlocks, blocks) {

        let translatedCode = '';

        if (rawBlocks.length) {
            for (let i = 0; i < rawBlocks.length; i++) {
                translatedCode += translateScript(rawBlocks[i]) + "\n";
            }
        }
        else
            translatedCode += translateScript(rawBlocks) + "\n";

        return translatedCode;
    }

    function translateScript(rawScript) {

        let shouldUpdate = true;
        let translatedScript = '';

        while (shouldUpdate) {
            translatedScript += translateBlock(rawScript) + "\n";
            if (Object.keys(rawScript).includes('next'))
                rawScript = rawScript['next']['block'];
            else
                shouldUpdate = false;
        }

        return translatedScript;
    }

    function translateBlock(rawBlock) {
        const blockName = rawBlock['_attributes']['type'];
        const category = /[a-z]+(?=_)/g.exec(blockName);
        const argsNumber = blocks[category[0]][blockName]['value'];
        const fieldsNumber = blocks[category[0]][blockName]['field'];
        let args = {};
        let translatedBlock = blocks[category[0]][blockName]['name'];

        if (argsNumber == 1) {
            if (Object.keys(rawBlock['value']).includes('block'))
                args[blocks[category[0]][blockName]['valueArgs']] = translateBlock(rawBlock['value']['block']);
            else {
                if (Object.keys(rawBlock['value']['shadow']['field']).includes('_text'))
                    args[blocks[category[0]][blockName]['valueArgs']] = rawBlock['value']['shadow']['field']['_text'];
                else
                    args[blocks[category[0]][blockName]['valueArgs']] = ' ';
            }
        }
        else if (argsNumber > 1) {
            for (let i = 0; i < argsNumber; i++) {
                if (Object.keys(rawBlock['value'][i]).includes('block'))
                    args[blocks[category[0]][blockName]['valueArgs'][i]] = translateBlock(rawBlock['value'][i]['block']);
                else {
                    if (Object.keys(rawBlock['value'][i]['shadow']['field']).includes('_text'))
                        args[blocks[category[0]][blockName]['valueArgs'][i]] = rawBlock['value'][i]['shadow']['field']['_text'];
                    else
                        args[blocks[category[0]][blockName]['valueArgs'][i]] = ' ';
                }
            }
        }

        if (fieldsNumber == 1) {
            if (Object.keys(rawBlock['field']).includes('block'))
                args[blocks[category[0]][blockName]['fieldArgs']] = translateBlock(rawBlock['field']['block']);
            else
                args[blocks[category[0]][blockName]['fieldArgs']] = rawBlock['field']['_text'];
        }
        else if (fieldsNumber > 1) {
            for (let i = 0; i < fieldsNumber; i++) {
                if (Object.keys(rawBlock['field'][i]).includes('block'))
                    args[blocks[category[0]][blockName]['fieldArgs'][i]] = translateBlock(rawBlock['field'][i]['block']);
                else
                    args[blocks[category[0]][blockName]['fieldArgs'][i]] = rawBlock['field'][i]['_text'];
            }
        }

        for (arg in args) {
            translatedBlock = translatedBlock.replace(arg, args[arg]);
        }

        return translatedBlock;
    }

    code = translate(jsonData, blocks);

    return code;
}